== Exceptions

Blocks in an ``++if++`` chain that contain a single line of code are ignored, as are blocks in a ``++switch++`` statement that contain a single line of code with or without a following ``++break++``.


----
if (a == 1) {
  doSomething();  //no issue, usually this is done on purpose to increase the readability
} else if (a == 2) {
  doSomethingElse();
} else {
  doSomething();
}
----

But this exception does not apply to ``++if++`` chains without ``++else++``-s, or to ``++switch++``-es without default clauses when all branches have the same single line of code. In case of ``++if++`` chains with ``++else++``-s, or of ``++switch++``-es with default clauses, rule S3923 raises a bug. 

----
if (a == 1) {
  doSomething();  //Noncompliant, this might have been done on purpose but probably not
} else if (a == 2) {
  doSomething();
}
----